/**
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.compdef.compDefText;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.MultiplicityRule;
import org.eclipse.papyrus.uml.textedit.common.xtext.umlCommon.TypeRule;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#isTypeUndefined <em>Type Undefined</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getMultiplicity <em>Multiplicity</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getValue <em>Value</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getComment <em>Comment</em>}</li>
 * </ul>
 *
 * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter()
 * @model
 * @generated
 */
public interface Parameter extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Type</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' containment reference.
   * @see #setType(TypeRule)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_Type()
   * @model containment="true"
   * @generated
   */
  TypeRule getType();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getType <em>Type</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' containment reference.
   * @see #getType()
   * @generated
   */
  void setType(TypeRule value);

  /**
   * Returns the value of the '<em><b>Type Undefined</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type Undefined</em>' attribute.
   * @see #setTypeUndefined(boolean)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_TypeUndefined()
   * @model
   * @generated
   */
  boolean isTypeUndefined();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#isTypeUndefined <em>Type Undefined</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type Undefined</em>' attribute.
   * @see #isTypeUndefined()
   * @generated
   */
  void setTypeUndefined(boolean value);

  /**
   * Returns the value of the '<em><b>Multiplicity</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Multiplicity</em>' containment reference.
   * @see #setMultiplicity(MultiplicityRule)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_Multiplicity()
   * @model containment="true"
   * @generated
   */
  MultiplicityRule getMultiplicity();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getMultiplicity <em>Multiplicity</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Multiplicity</em>' containment reference.
   * @see #getMultiplicity()
   * @generated
   */
  void setMultiplicity(MultiplicityRule value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' containment reference.
   * @see #setValue(Value)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_Value()
   * @model containment="true"
   * @generated
   */
  Value getValue();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getValue <em>Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' containment reference.
   * @see #getValue()
   * @generated
   */
  void setValue(Value value);

  /**
   * Returns the value of the '<em><b>Comment</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Comment</em>' attribute.
   * @see #setComment(String)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getParameter_Comment()
   * @model
   * @generated
   */
  String getComment();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter#getComment <em>Comment</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Comment</em>' attribute.
   * @see #getComment()
   * @generated
   */
  void setComment(String value);

} // Parameter
